#ifndef DATABASE_H
#define DATABASE_H

#include "seller.h"

#include <string>

#include <sqlite3.h>

class Database
{
  public:
    Database(const std::string& dbname);
    ~Database();
    Database(const Database&) = delete;
    Database& operator=(const Database&) = delete;
    void exec(const std::string& sql);
    void init();
    unsigned int storeSellers(std::vector<std::shared_ptr<Seller>>& sellers);

  private:
    sqlite3* db_;
    std::string dbname_;
    void beginTransaction();
    void endTransaction();
    void createNew();
    int getVersion();
    unsigned int storeArticles(sqlite3_stmt* stmt, std::vector<Article*> articles);
};

#endif // DATABASE_H